var _mythemes_plg_bk_layout = function( options, layouts ){

    var _mythemes_plg_templates = {
        ''          : 'Basic White',
        'dark'      : 'Basic Dark',
        'flat'      : 'Flat White',
        'flat dark' : 'Flat Dark'
    };

    var _mythemes_plg_contrasts = {
        0.1 : 1,
        0.2 : 2,
        0.3 : 3,
        0.4 : 4,
        0.5 : 5,
        0.6 : 6,
        0.7 : 7,
        0.8 : 8,
        0.9 : 9
    };

    var _layout = function( options ){
        this.options = {
            index       : 0,
            total       : 0,
            slug        : 'mythemes-plg-layouts',
            container   : '#mythemes-plg-layouts'
        };

        if( typeof options == 'object' )
            this.options = _mythemes_plg_normalize( this.options , options );  
    }

    _layout.prototype.ID = function( layout ){
        if( layout.hasOwnProperty( 'id' ) && layout.id === 0 ){
            var d = new Date();
            layout.id = d.getTime();
        }

        return layout;
    }
    _layout.prototype.prev = function( layout ){
        if( layout.hasOwnProperty( 'id' ) && !layout.hasOwnProperty( 'prev' ) ){
            layout.prev = 0;
        }

        return layout;
    }
    _layout.prototype.pause = function( layout ){
        if( layout.hasOwnProperty( 'id' ) && !layout.hasOwnProperty( 'pause' ) ){
            layout.pause = 0;
        }

        return layout;
    }

    _layout.prototype.add = function( layout ){
        if( typeof layout !== 'object' )
            return;

        var self    = this;
        var options = this.options;

        layout = this.prev( layout );
        layout = this.pause( layout );

        layout = _mythemes_plg_normalize( _mythemes_plg_default.layout , layout );

        layout = this.ID( layout );

        _mythemes_plg_options.layouts[ layout.id ] = layout;

        var element = jQuery( self.html( layout ) );

        // SHOW / HIDE
        element.children( '.' + options.slug + '-header' ).click(function(){
            var icon = jQuery( this ).children( 'a.details-icon' );
            jQuery( this ).parent().children( '.' + options.slug + '-content' ).toggle( 'slow' , function(){
                if( !jQuery( icon ).hasClass( 'up' ) ){
                    jQuery( icon ).addClass( 'up' );
                    jQuery( 'div.mythemes-plg-tooltip' , element ).show( 'slow' );
                }
                else{
                    jQuery( icon ).removeClass( 'up' );
                    jQuery( 'div.mythemes-plg-tooltip' , element ).hide();
                }
            });
        });
        
        // DELETE
        element.children( '.' + options.slug + '-header' ).children( 'a.delete-icon' ).click(function(){
            if( confirm( "Are you sure you want to delete this layout!" ) ){
                jQuery( this ).parent().parent().toggle( 'slow' , function(){
                    jQuery( this ).remove();
                    self.reset_counter();
                });
            }
        });
        
        
        // CHANGE ELEMENTS
        jQuery( 'input[type="text"].mythemes-plg-pickcolor.mythemes-plg-color' ,  element ).focus(function(){
            if( jQuery( this ).val().length > 2 ){
                self.overflowStyle( element , layout );
            }
        });
        jQuery( 'input[type="text"].mythemes-plg-pickcolor.mythemes-plg-color' ,  element ).focusout(function(){
            if( jQuery( this ).val().length > 2 ){
                self.overflowStyle( element , layout );
            }
        });
        jQuery( 'input[type="text"].mythemes-plg-pickcolor.mythemes-plg-color' ,  element ).keyup(function(){
            if( jQuery( this ).val().length > 2 ){
                jQuery('style#' + _mythemes_plg_layout_ID( layout.id ) ).html( _mythemes_plg_layout_css( layout ) );
                jQuery( 'a.pickcolor.hide-if-no-js' , element ).css( { 'background-color' : layout.color } );
            }
        });
        
        jQuery( 'input[type="text"].mythemes-plg-title' ,  element ).keyup(function(){
            if( jQuery( this ).val().length > 0 ){
                jQuery( 'div.mythemes-plg-content strong.mythemes-plg-title').text( jQuery( this ).val() );
            }
        });
        jQuery( 'select.mythemes-plg-template' ,element ).on( 'change' , function(){
            jQuery( 'option' , this ).each(function(){
                if( jQuery( this ).is(':selected') ){
                    layout.template = jQuery( this ).val();
                    self.overflowStyle( element , layout );
                }
            });
        });
        jQuery( 'select.mythemes-plg-contrast' ,element ).on( 'change' , function(){
            jQuery( 'option' , this ).each(function(){
                if( jQuery( this ).is(':selected') ){
                    layout.contrast = jQuery( this ).val();
                    self.overflowStyle( element , layout );
                }
            });
        });
        
        element.appendTo( jQuery( options.container ) );


        // ADD TOOLTIP TO CONTAINER
        var tooltip = jQuery( _mythemes_plg_tooltip_html( _mythemes_plg_tooltip({
            id : layout.id,
            title : layout.title,
            custom_layout : 1,
            layout : layout.id.toString(),
            selector : '#' + this.attrID() + ' div.mythemes-plg-coll.preview',
            content : 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi nec mauris tempus, facilisis purus vitae, venenatis metus. Interdum et malesuada fames ac ante ipsum primis in faucibus. Mauris vitae purus vitae orci pharetra hendrerit a in mauris. Maecenas eros orci, euismod ...',
            nr : options.index + 1,
            group_total : 1,
            preview : 1
        })));

        tooltip.appendTo( jQuery( '#' + this.attrID() + ' div.mythemes-plg-coll.preview' ) );

        this.reset_counter();
        
        mythemes_plg_ahtml.init.all();
        
        options.index++;
    }

    _layout.prototype.html = function( layout ){

        var content = '';
        var options = this.options;
            
        content += mythemes_plg_ahtml.hidden({
            slug : 'id',
            value : layout.id,
            inputID : options.slug + '-' + layout.id + '-id',
            inputName : options.slug + '[' + layout.id + '][id]'
        });
        
        content += '<div class="mythemes-plg-colls-2">';
        content += '<div class="mythemes-plg-coll">';
        
        content += mythemes_plg_ahtml.field({
            type : {
                field : 'inlist',
                input : 'text'
            },
            slug : 'title',
            label : 'Layout Title',
            value : layout.title,
            inputID : options.slug + '-' + layout.id + '-title',
            inputName : options.slug + '[' + layout.id + '][title]'
        });
        
        content += mythemes_plg_ahtml.field({
            type : {
                field : 'inlist',
                input : 'select'
            },
            values : _mythemes_plg_templates,
            slug : 'template',
            label : 'Template',
            value : layout.template,
            inputID : options.slug + '-' + layout.id + '-template',
            inputName : options.slug + '[' + layout.id + '][template]'
        });
        
        content += mythemes_plg_ahtml.field({
            type : {
                field : 'inlist',
                input : 'color'
            },
            slug : 'color',
            label : 'Color',
            value : layout.color,
            inputName : options.slug + '[' + layout.id + '][color]',
            inputID : options.slug + '-' + layout.id + '-color',
            opName : options.slug + '-' + layout.id + '-color',
            action : 'mythemes_plg_bk_layout.overflowStyle( "#' + this.attrID() + '" , ' + JSON.stringify( layout ) + ' );'
        });
        
        content += mythemes_plg_ahtml.field({
            type : {
                field : 'inlist',
                input : 'select'
            },
            values : _mythemes_plg_contrasts,
            slug : 'contrast',
            label : 'Button Contrast',
            value : layout.contrast,
            hint : 'Contrast between border and background',
            inputID : options.slug + '-' + layout.id + '-contrast',
            inputName : options.slug + '[' + layout.id + '][contrast]'
        });
        
        var classes = {
            pause : 'mythemes-plg-pause',
            prev : 'mythemes-plg-prev'
        };
        
        content += mythemes_plg_ahtml.field({
            type : {
                field : 'inlist',
                input : 'logic'
            },
            slug : 'pause',
            label : 'Show Pause Button',
            value : layout.pause,
            inputID : options.slug + '-' + layout.id + '-pause',
            inputName : options.slug + '[' + layout.id + '][pause]',
            action : {
                show : [ '#' + options.slug + '-' + options.index + ' div.mythemes-plg-tooltip a.' + classes.pause ]
            }
        });
        
        if( layout.pause == 0 )
            classes.pause += ' hidden';
        
        content += mythemes_plg_ahtml.field({
            type : {
                field : 'inline',
                input : 'logic'
            },
            slug : 'prev',
            label : 'Show Previous Button',
            value : layout.prev,
            inputID : options.slug + '-' + layout.id + '-prev',
            inputName : options.slug + '[' + layout.id + '][prev]',
            action : {
                show : [ '#' + options.slug + '-' + options.index + ' div.mythemes-plg-tooltip span.' + classes.prev ]
            }
        });
        
        if( layout.prev == 0 )
            classes.prev += ' hidden';
        
        content += '</div>';
        
        // START TOOLTIP CONTAINER
        content += '<div class="mythemes-plg-coll preview">';
        
        content += _mythemes_plg_layout_style( layout );
        
        content += '</div>';
        // END TOOLTIP CONTAINER
        
        content += '<div class="clear clearfix"></div>';

        // RETURN
        var rett = '';

        rett += '<div class="' + options.slug + '" id="' + this.attrID() + '">';
        // HEADER
        rett += '<div class="' + options.slug + '-header">';
        rett += '<strong class="header-title">' + layout.title + '</strong>';

        rett += '<a class="delete-icon" href="javascript:void(null);"></a>';
        rett += '<a class="details-icon" href="javascript:void(null);"></a>';

        rett += '</div>';

        // CONTENT
        rett += '<div class="' + options.slug + '-content hidden">';

        rett += content;

        rett += '</div>';
        rett += '</div>';

        return rett;
    }

    _layout.prototype.attrID = function(){
        return options.slug + '-' + options.index;
    }

    _layout.prototype.reset_counter = function(){
        var options = this.options;
        var total   = jQuery( options.container + ' div.' + options.slug  ).length;
        var self    = this;

        jQuery( options.container + ' div.' + options.slug  ).each(function(){
            jQuery( this ).find( 'div.' + _mythemes_plg_tooltip_slug() )
            .find( '.mythemes-plg-counter' )
            .children( 'span' )
            .text( total );
        });
    }

    _layout.prototype.overflowStyle = function( element, layout ){

        jQuery( 'div.' + _mythemes_plg_tooltip_slug() , jQuery( element ) ).attr( 'class' , _mythemes_plg_tooltip_slug() + ' ' + _mythemes_plg_layout_classes( layout ) );

        layout.color = jQuery( 'input[type="text"].mythemes-plg-pickcolor.mythemes-plg-color' , jQuery( element ) ).val();
        jQuery( 'a.pickcolor.hide-if-no-js' , jQuery( element ) ).css( { 'background-color' : layout.color } );
        jQuery('style#' + _mythemes_plg_layout_ID( layout.id ) ).html( _mythemes_plg_layout_css( layout ) );
        jQuery( 'input[type="text"].mythemes-plg-pickcolor.mythemes-plg-color' , jQuery( element ) ).attr( 'rel' , 'mythemes_plg_bk_layout.overflowStyle( "#mythemes-plg-layouts-' + jQuery( element ).index() + '" , ' + JSON.stringify( layout ) + ' );' );
    }

    _layout.prototype.addLayouts = function( layouts ){
        for( var i in layouts ){
            if( layouts.hasOwnProperty( i ) ){
                this.add( layouts[ i ] );
            }
        }    
    }

    var layout = new _layout( options );
    layout.addLayouts( layouts );

    return layout;
}